% Example on the use of the function emcontinc
% load data
  data; 
  [n,J] = size(Y);
  nco = size(Z,2);
% put in a multinomial form
  Ym = zeros(n,2^J);
  for i = 1:n,
    ind = (2.^(J-1:-1:0))*Y(i,:)' + 1;
    Ym(i,ind) = 1;
  end
% aggregate data with the sampe covariate configuration
  Za = Z(1,:); Ya = Ym(1,:); na = 1;
  for i = 2:n,
    flag = 1;    
    for j = 1:na,
      if all(Z(i,:) == Za(j,:)),
        Ya(j,:) = Ya(j,:)+Ym(i,:);
        flag = 0;
      end
    end
    if flag,
      Za = [Za; Z(i,:)];
      Ya = [Ya; Ym(i,:)];
      na = na+1;
    end
  end
  [Za,ind] = sortrows(Za); Ya = Ya(ind,:);
% LC with covariate effect only on the conditional distributions with C = 1
  Bm = eye(J); C = 1;
  X = zeros(J,J+nco*J,na);
  for i = 1:na,
    X(:,:,i) = [eye(J) kron(eye(J),Za(i,:))];                              % intercepts and coefficient conditional
  end  
  [lk1,bic1,N1,be1,Pi1,P1,wref1,Pcref1,F1] = emcontinc(Ya,J,C,X,Bm);
% LC with covariate effect on the CONDITIONAL DISTRIBUTION and DISTRIBUTION OF WEIGHTS with C = 2
  Bm = eye(J); C = 2;
  X = zeros(C-1+C*J,C-1+C*J+nco*(C-1)+nco*J,na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    Xi3 = kron(eye(C-1),Za(i,:));                                          % coefficients weights
    Xi4 = kron(ones(C,1),kron(eye(J),Za(i,:)));                            % coefficients conditional
    X(:,:,i) = [blkdiag(Xi1,Xi2) blkdiag(Xi3,Xi4)];
  end
  [lk2,bic2,N2,be2,Pi2,P2,wref2,Pcref2,F2] = emcontinc(Ya,J,C,X,Bm);
% LC with covariate effect on the CONDITIONAL DISTRIBUTION and DISTRIBUTION OF WEIGHTS with C = 3
  Bm = eye(J); C = 3;
  X = zeros(C-1+C*J,C-1+C*J+nco*(C-1)+nco*J,na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    Xi3 = kron(eye(C-1),Za(i,:));                                          % coefficients weights
    Xi4 = kron(ones(C,1),kron(eye(J),Za(i,:)));                            % coefficients conditional
    X(:,:,i) = [blkdiag(Xi1,Xi2) blkdiag(Xi3,Xi4)];
  end
  [lk3,bic3,N3,be3,Pi3,P3,wref3,Pcref3,F3] = emcontinc(Ya,J,C,X,Bm);
% ****** CONSTRAINED MODELS ******
% LC with covariate effect on the CONDITIONAL DISTRIBUTION with C = 2
  Bm = eye(J); C = 2;
  X = zeros(C-1+C*J,C-1+C*J+nco*J,na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    Xi4 = kron(ones(C,1),kron(eye(J),Za(i,:)));                            % coefficients conditional
    X(:,:,i) = [blkdiag(Xi1,Xi2) [zeros(C-1,nco*J); Xi4]];
  end
  [lk2c,bic2c,N2c,be2c,Pi2c,P2c,wref2c,Pcref2c,F2c] = emcontinc(Ya,J,C,X,Bm);
% LC with covariate effect on the DISTRIBUTION OF WEIGHTS with C = 2
  Bm = eye(J); C = 2;
  X = zeros(C-1+C*J,C-1+C*J+nco*(C-1),na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    Xi3 = kron(eye(C-1),Za(i,:));                                          % coefficients weights
    X(:,:,i) = [blkdiag(Xi1,Xi2) [Xi3; zeros(C*J,nco*(C-1))]];
  end
  [lk2w,bic2w,N2w,be2w,Pi2w,P2w,wref2w,Pcref2w,F2w] = emcontinc(Ya,J,C,X,Bm);
% LC without covariate effect on the CONDITIONAL DISTRIBUTION and DISTRIBUTION OF WEIGHTS with C = 2
  Bm = eye(J); C = 2;
  X = zeros(C-1+C*J,C-1+C*J,na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    X(:,:,i) = blkdiag(Xi1,Xi2);
  end
  [lk2lc,bic2lc,N2lc,be2lc,Pi2lc,P2lc,wref2lc,Pcref2lc,F2lc] = emcontinc(Ya,J,C,X,Bm);
% LC with covariate effect on the CONDITIONAL DISTRIBUTION and DISTRIBUTION OF WEIGHTS with C = 2
% and interaction effects between covariates + association between the first two lists
  Bm = fliplr([sq(J,1); sq(J,2); sq(J,3)]); C = 2; ass = 1;
  X = zeros(C-1+C*(J+4),C-1+C*J+nco*(C-1)+nco*J+1,na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = kron(eye(C),[eye(J); zeros(4,J)]);                               % intercepts conditional
    Xi3 = kron(eye(C-1),Za(i,:));                                          % coefficients weights
    Xi4 = kron(ones(C,1),kron([eye(J); zeros(4,J)],Za(i,:)));              % coefficients conditional
    ve = zeros(J+4,1); ve(J+ass) = 1;
    Xi5 = [zeros(C-1,1); kron(ones(C,1),ve)];
    X(:,:,i) = [blkdiag(Xi1,Xi2) blkdiag(Xi3,Xi4) Xi5];
  end
  be2a = [be2; 0];
  [lk2a,bic2a,N2a,be2a,Pi2a,P2a,wref2a,Pcref2a,F2a] = emcontinc(Ya,J,C,X,Bm,be2a);
% *** Confidence interval for the populations size ***
% LC with covariate effect on the WEIGHTS with C = 2
  Bm = eye(J); C = 2;
  X = zeros(C-1+C*J,C-1+C*J+nco*(C-1),na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    Xi3 = kron(eye(C-1),Za(i,:));                                          % coefficients weights
    X(:,:,i) = [blkdiag(Xi1,Xi2) [Xi3; zeros(C*J,nco*(C-1))]];
  end
  Nl = (N2w:5:N2w+80)'; G2l = zeros(length(Nl),1);
  N = Nl(1); Y = Ya; Y(:,1) = maxcond(N,Ya,[1-sum(P2w,2) P2w]);
  [lk,be,Pi,P] = emcontcomp(Y,J,C,X,Bm,be2w);
  for i = 1:length(Nl),               
    N = Nl(i);
    Y(:,1) = maxcond(N,Y,P);
    [lk,be,Pi,P] = emcontcomp(Y,J,C,X,Bm,be);
    N0 = sum(Y,2); lk0 = sum(sum(Y.*log(diagv(1./N0,max(Y,eps)))));
    G2 = -2*(lk-lk0); G2o = G2; it = 0;
    while abs(G2-G2o)/G2o>5*10^-8 | it==0,
      it = it+1;
      Y(:,1) = maxcond(N,Y,P);
      [lk,be,Pi,P] = emcontcomp(Y,J,C,X,Bm,be);
      N0 = sum(Y,2); lk0 = sum(sum(Y.*log(diagv(1./N0,max(Y,eps)))));
      G2o = G2; G2 = -2*(lk-lk0);
      disp('----------------------------------------------------------');
      disp([i it G2 G2o-G2 abs(G2-G2o)/G2o]);
      disp('----------------------------------------------------------');
    end
    G2l(i) = G2;
  end
  Nl1 = Nl; G2l1 = G2l;
  Nl = (N2w:-5:N2w-50)'; G2l = zeros(length(Nl),1);
  N = Nl(1); Y = Ya; Y(:,1) = maxcond(N,Ya,[1-sum(P2w,2) P2w]);
  [lk,be,Pi,P] = emcontcomp(Y,J,C,X,Bm,be2w);
  for i = 1:length(Nl),               
    N = Nl(i);
    Y(:,1) = maxcond(N,Y,P);
    [lk,be,Pi,P] = emcontcomp(Y,J,C,X,Bm,be);
    N0 = sum(Y,2); lk0 = sum(sum(Y.*log(diagv(1./N0,max(Y,eps)))));
    G2 = -2*(lk-lk0); G2o = G2; it = 0;
    while abs(G2-G2o)/G2o>5*10^-8 | it==0,
      it = it+1;
      Y(:,1) = maxcond(N,Y,P);
      [lk,be,Pi,P] = emcontcomp(Y,J,C,X,Bm,be);
      N0 = sum(Y,2); lk0 = sum(sum(Y.*log(diagv(1./N0,max(Y,eps)))));
      G2o = G2; G2 = -2*(lk-lk0);
      disp('----------------------------------------------------------');
      disp([i it G2 G2o-G2 abs(G2-G2o)/G2o]);
      disp('----------------------------------------------------------');
    end
    G2l(i) = G2;
  end  
  Nl = [flipud(Nl); Nl1(2:end)]; G2l = [flipud(G2l); G2l1(2:end)];
% plot confidence interval
  NC = N2w;
  set(gcf,'Units','centimeters','Position',[2 2 14 10.5]);
  set(gcf,'PaperUnits','centimeters','PaperPosition',[2 2 14 10.5],'PaperPositionMode','Manual');
  Nl1 = (850:0.05:930)';
  G2l1 = interp1(Nl(find(G2l>0)),G2l(find(G2l>0)),Nl1,'spline'); G2l1 = G2l1-min(G2l1);
  plot(Nl1,G2l1,'k');
  [mc,ic] = min(G2l1); NCp = Nl1(ic);
  ind = find(G2l1<=3.841); 
  i1 = min(ind(find(ind<ic)));
  i2 = max(ind(find(ind>ic)));
  NC1 = Nl1(i1); NC2 = Nl1(i2);
  m1 = G2l1(i1); m2 = G2l1(i2);
  hold on
  line([Nl1(1)-5 NC2],[3.841 3.841],'Color','k','LineStyle',':');
  line([NC1 NC1],[min(G2l1) m1],'Color','k','LineStyle',':');
  line([NC2 NC2],[min(G2l1) m2],'Color','k','LineStyle',':');
  line([NC NC],[min(G2l1) 0.35],'Color','k','LineStyle',':');
  hold off
  xlabel('\it N','Fontname','Times New Roman','Fontsize',10);
  ylabel('{\it G}^2({\it N})','Fontname','Times New Roman','Fontsize',10);
  text(851,4.041,'3.841','Fontname','Times New Roman','Fontsize',10);
  text(NC1-6,0.2,'858.6','Fontname','Times New Roman','Fontsize',10);
  text(NC2+1,0.2,'912.6','Fontname','Times New Roman','Fontsize',10);
  text(NC-2.5,0.55,'881.5','Fontname','Times New Roman','Fontsize',10);
  set(gca,'Fontname','Times New Roman','Fontsize',10,'TickDir','out','Box','off');
  axis([850 920 0 6]);
% save workspace
  save example