% Example on the use of the function emcontinc
% load data
  [n,J] = size(Y);
  nco = size(Z,2);
% put in a multinomial form
  Ym = zeros(n,2^J);
  for i = 1:n,
    ind = (2.^(J-1:-1:0))*Y(i,:)' + 1;
    Ym(i,ind) = 1;
  end
% aggregate data with the sampe covariate configuration
  Za = Z(1,:); Ya = Ym(1,:); na = 1;
  for i = 2:n,
    flag = 1;    
    for j = 1:na,
      if all(Z(i,:) == Za(j,:)),
        Ya(j,:) = Ya(j,:)+Ym(i,:);
        flag = 0;
      end
    end
    if flag,
      Za = [Za; Z(i,:)];
      Ya = [Ya; Ym(i,:)];
      na = na+1;
    end
  end
  [Za,ind] = sortrows(Za); Ya = Ya(ind,:);
% LC with covariate effect only on the conditional distributions with C = 1
  Bm = eye(J); C = 1;
  X = zeros(J,J,na);
  for i = 1:na,
    X(:,:,i) = eye(J);                              % intercepts and coefficient conditional
  end  
  [lk1,bic1,N1,be1,Pi1,P1,wref1,Pcref1,F1] = emcontinc(Ya,J,C,X,Bm);
% LC with covariate effect on the CONDITIONAL DISTRIBUTION and DISTRIBUTION OF WEIGHTS with C = 2
  Bm = eye(J); C = 2;
  X = zeros(C-1+C*J,C-1+C*J,na);
  for i = 1:na,
    Xi1 = eye(C-1);                                                        % intercepts weights
    Xi2 = eye(C*J);                                                        % intercepts conditional
    X(:,:,i) = blkdiag(Xi1,Xi2);
  end
  [lk2,bic2,N2,be2,Pi2,P2,wref2,Pcref2,F2] = emcontinc(Ya,J,C,X,Bm);
